#include <hmg.ch>
#define TAB_BASIS 1
#define TAB_EXTRA 2

*------------------------------------------------------------------------------*
FUNCTION DoART()
*------------------------------------------------------------------------------*
	PRIV aART_Ctrl_1 := {'TEXTBOX','NUMERIC','9999999'}
	PRIV aART_Ctrl_2 := {'TEXTBOX','CHARACTER'}
	PRIV aART_Ctrl_3 := {'TEXTBOX','NUMERIC','999'}
	PRIV aART_Ctrl_4 := {'TEXTBOX','NUMERIC','9999999'}
	PRIV aART_Ctrl_5 := {'TEXTBOX','CHARACTER'}
	
	PRIV nRecno_ART := 0
	PRIV lNew := .F.
	IF ! IsWindowDefined( Win_ART_MAIN )
		Load Window Win_ART_MAIN
		Win_ART_MAIN.Center
		Win_ART_MAIN.Activate
	ENDIF
RETURN

*------------------------------------------------------------------------------*
FUNCTION OnInit_Win_ART()
*------------------------------------------------------------------------------*
	ON KEY ESCAPE OF Win_ART_GRID ACTION ART_Button_Close()
	SELECT ART
	ART->(DBSetorder('ARTL01'))
	ART->(DBGotop())
	ART_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_RefreshScreen()
*------------------------------------------------------------------------------*
	LOCAL nRecno := ART->(recno())
	Win_ART_GRID.Grid_ART.Refresh 
	Win_ART_GRID.Grid_ART.RecNo := nRecno
	Win_ART_GRID.Grid_ART.Setfocus
	ART_RefreshData()
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_RefreshData()
*------------------------------------------------------------------------------*
	IF Win_ART_GRID.Grid_ART.RecNo > ART->(Lastrec()) 
		ART_Button_Add()
	ELSE
		ART_Edit()
	ENDIF
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_Button_Image_Photo()
*------------------------------------------------------------------------------*
	LOCAL cFile := Getfile( { {'jpg Files','*.jpg'} , {'gif Files','*.gif'} , {'bmp Files','*.bmp'} } , 'Select Image' , GetStartUpFolder()+'\Photos' , .F. )
	IF ! EMPTY( cFile )
		Win_ART_DATA.Text_Photo.Value    := cFile
		Win_ART_DATA.Image_Photo.Picture := cFile
	ENDIF
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_Button_Add()
*------------------------------------------------------------------------------*
	lNew := .T.

	Win_ART_MAIN.StatusBar.Item(1) := 'Record   ' + LTRIM( STR( ART->( Lastrec()+1 ) ) )
	Win_ART_MAIN.StatusBar.Item(2) := 'Add record' 

	Win_ART_DATA.Tab_ART.Value     := TAB_BASIS
	Win_ART_DATA.Text_ArtID.Value  := ART_NewArtID()
	Win_ART_DATA.Text_ArtOm.Value  := ""
	Win_ART_DATA.Text_Mag.Value    := ""
	Win_ART_DATA.Text_Photo.Value  := ""
	Win_ART_DATA.Image_Photo.Show
	Win_ART_DATA.Image_Photo.Picture := '0.bmp'
	
	Win_ART_DATA.Text_ArtID.Enabled := .T.
	Win_ART_DATA.Text_ArtID.Setfocus 
	Win_ART_GRID.ART_Button_Delete.Enabled := .F.	
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_NewArtID()
*------------------------------------------------------------------------------*
	LOCAL nArtID
	LOCAL nIndex := ART->(Indexord())
		
	ART->(DBSetorder('ARTL01') )
	ART->(DBGoBottom())
	nArtID := ART->ArtID + 1
	ART->(DBSetorder(nIndex))
	ART->(DBGoto( nRecno_ART ))
	msgdebug( 'Record ' + NTOC(nRecno_ART) + '    Article ' + NTOC(ART->ARTID) )
RETURN nArtID

*------------------------------------------------------------------------------*
FUNCTION ART_Edit()
*------------------------------------------------------------------------------*
	lNew := .F.
	
	ART->(DBGoto( nRecno_ART := Win_ART_GRID.Grid_ART.RecNo ))
	
	Win_ART_MAIN.StatusBar.Item(1) := 'Record   ' + LTRIM( STR( ART->( Recno()   ) ) ) + ;
									        ' / ' + LTRIM( STR( ART->( Lastrec() ) ) )  
	Win_ART_MAIN.StatusBar.Item(2) := 'Modify record' 

	Win_ART_DATA.Text_ArtID.Value  := ART->ArtID
	Win_ART_DATA.Text_ArtOm.Value  := ART->ArtOm
	Win_ART_DATA.Text_Mag.Value    := ART->Mag
	Win_ART_DATA.Text_Photo.Value  := ART->Photo
	IF FILE( Win_ART_DATA.Text_Photo.Value )
		Win_ART_DATA.Image_Photo.Show
		Win_ART_DATA.Image_Photo.Picture := Win_ART_DATA.Text_Photo.Value
	ELSE
		IF FILE( GetStartUpFolder() + '\Photos\0.bmp' )
			Win_ART_DATA.Image_Photo.Show
			Win_ART_DATA.Image_Photo.Picture := GetStartUpFolder() + '\Photos\0.bmp'
		ELSE
			Win_ART_DATA.Image_Photo.Hide
		ENDIF
	ENDIF
	
	Win_ART_DATA.Text_ArtID.Enabled := .F.
	Win_ART_GRID.ART_Button_Delete.Enabled := .T.	
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_SortColumn( cSort )
*------------------------------------------------------------------------------*
	ART->(DBSetorder( cSort ))
	ART->(DBGoto( nRecno_ART ))
	ART_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_OnDblClick()
*------------------------------------------------------------------------------*
	Win_ART_DATA.Text_ArtOm.Setfocus
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_OnEnter_Text_ArtID()
*------------------------------------------------------------------------------*
	Win_ART_DATA.Text_ArtOm.Setfocus
RETURN

FUNCTION ART_OnEnter_Text_ArtOm()
	Win_ART_DATA.Text_Mag.Setfocus
RETURN

FUNCTION ART_OnEnter_Text_Mag()
	Win_ART_DATA.Tab_ART.Value := TAB_EXTRA
	Win_ART_DATA.Text_Photo.Setfocus
RETURN

FUNCTION ART_OnEnter_Text_Photo()
	ART_Button_Save()
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_Button_Save()
*------------------------------------------------------------------------------*
	LOCAL nArtID := Win_ART_DATA.Text_ArtID.Value
	
	IF lNew == .T.
		IF nArtID <= 0
			Win_ART_DATA.Tab_ART.Value := TAB_BASIS
			MsgSTOP('Article must be > 0' , 'Controle')		
			Win_ART_DATA.Text_ArtID.Setfocus
			RETURN Nil
		ENDIF
		
		IF Exist('ART','ARTL01',nArtID)
			Win_ART_DATA.Tab_ART.Value := TAB_BASIS
			MsgSTOP('Article ' + ALLTRIM(STR(nArtID)) + ' already exists' , 'Controle')
			Win_ART_DATA.Text_ArtID.Setfocus
			RETURN Nil
		ENDIF
	ENDIF

	IF EMPTY( Win_ART_DATA.Text_ArtOm.Value )
		Win_ART_DATA.Tab_ART.Value := TAB_BASIS
		MsgSTOP('Empty description' , 'Controle')
		Win_ART_DATA.Text_ArtOm.Setfocus
		RETURN Nil
	ENDIF
	
	IF lNew == .T.
		ART->(DBAppend())
		ART->(RLock())
		ART->ArtID := Win_ART_DATA.Text_ArtID.Value
		ART_UpdDb()
	ELSE
		ART->(DBGoto( nRecno_ART ))
		IF RecLocked('ART')
			ART_UpdDb()	
		ENDIF
	ENDIF
	
	Win_ART_GRID.GRID_ART.Value := ART->(recno())
	ART_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_UpdDb()
*------------------------------------------------------------------------------*
	ART->ArtOm := Win_ART_DATA.Text_ArtOm.Value
	ART->Mag   := Win_ART_DATA.Text_Mag.Value
	ART->Photo := Win_ART_DATA.Text_Photo.Value
	ART->(DBCommit())
	ART->(DBUnlock())
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_Button_Delete()
*------------------------------------------------------------------------------*
	ART->(DBGoto( nRecno_ART ))
	IF ! ART->(EOF())
		IF MsgOkCancel ("Delete article " + ALLTRIM(STR(ART->ArtID)) + " " + ALLTRIM(ART->ArtOm), 'Controle')
		
			IF RecLocked('ART')
				ART->(DBDelete())
				ART->(DBUnlock())
				ART->(DBSkip())
				IF ART->(EOF())
					ART->(DBGoBottom())
				ENDIF
				ART_RefreshScreen()
			ENDIF
			
		ENDIF
	ENDIF
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_Button_Refresh()
*------------------------------------------------------------------------------*
	ART_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_Button_Print()
*------------------------------------------------------------------------------*
RETURN

*------------------------------------------------------------------------------*
FUNCTION ART_Button_Close()
*------------------------------------------------------------------------------*
	Win_ART_MAIN.Release
RETURN

*------------------------------------------------------------------------------*
FUNCTION OnRelease_Win_ART()
*------------------------------------------------------------------------------*
	Win_ART_DATA.Release
	Win_ART_GRID.Release
RETURN

*------------------------------------------------------------------------------*
FUNCTION GetArtOm( nArtID )
*------------------------------------------------------------------------------*
	LOCAL cArtOm
	IF Exist('ART','ARTL01',nArtID)
		cArtOm := ART->ArtOm
	ELSE	
		cArtOm := ''
	ENDIF
RETURN cArtOm

